import TradeModel from "../../common/BasicFunctions/PageFunctions/TradeModel";
import { IPage } from "../Interfaces/Ipage";
import { PageContainerHelper } from "../PagesHelper/PageContainerHelper";
import { PageHelper } from "../PagesHelper/PageHelper";
import { PageContainer } from "./PageContainer";



class TradePage implements IPage {
    // private _ready: EventHandler | null = null;
    // private _propertyChanged: PropertyChangedEventHandler | null = null;//hulei-s 微软自带

    constructor() {
        // 模拟加载事件
        // this.triggerLoad();
    }
    GetTradeInfoData(): unknown {
        throw new Error("Method not implemented.");
    }

    get TradeModel(): TradeModel {
        return PageHelper.GetTradeModel(this) as TradeModel;
    }

    set TradeModel(value: TradeModel) {
        PageHelper.SetTradeModel(this, value);
    }

    // get Ready() {
    //     return {
    //         add: (handler: EventHandler) => {
    //             this.Ready = handler;
    //         },
    //         remove: (handler: EventHandler) => {
    //             if (this.Ready === handler) {
    //                 this.Ready = null;
    //             }
    //         },
    //     };
    // }

    // private triggerLoad() {
    //     PageHelper.SetOwnerPage(this, this);
    //     if (this._ready) {
    //         this._ready(this, {});
    //     }
    //     this.onTradePageLoaded();
    // }


    get OwnerContainer(): PageContainer {
        return PageContainerHelper.GetOwnerContainer(this) as PageContainer;
    }

    SetOwnerContainer(pageContainer: PageContainer) {
        PageContainerHelper.SetOwnerContainer(this, pageContainer);
    }

    get InstanceId(): string {
        return PageContainerHelper.GetInstanceId(this) as string;
    }

    SetInstanceId(guid: string) {
        PageContainerHelper.SetInstanceId(this, guid);
    }

    get ViewStateData(): { [key: string]: any } {
        return PageHelper.GetViewStateData(this);
    }

    SetViewStateData(viewStateData: { [key: string]: any }) {
        if (!viewStateData) {
            viewStateData = {};
        }
        PageHelper.SetViewStateData(this, viewStateData);
    }

    get PropertyChanged() {
        // return {
        //     add: (handler: PropertyChangedEventHandler) => {
        //         this.PropertyChanged = handler;
        //     },
        //     remove: () => {
        //         if (this.PropertyChanged === handler) {
        //             this.PropertyChanged = null;
        //         }
        //     },
        // };
        return null
    }

    // protected raisePropertyChanged(propertyName: string) {
    //     if (this.PropertyChanged) {
    //         this.PropertyChanged(this, { propertyName });
    //     }
    // }
}

export default TradePage;
