import Message from "@/views/front/develop/Communication/Message";
import type { SubmitEntry } from "@/views/front/develop/Contract/Entry/SubmitEntry";

/**
 * 提交契约接口
 */
export interface ISubmitContract {
    /**
     * 提交准备
     * @param message 输出参数，返回生成的报文
     * @returns 准备是否成功
     */
    PreviewSubmitting(message: Message | null): boolean

    /**
     * 提交入口
     */
    readonly SubmitEntry: SubmitEntry
}
