// 模拟 ComboBoxHelper 类
class ComboBoxHelper {
    static GetIsAutoComplete(target: any): boolean {
        // 模拟实现，实际使用时需根据业务逻辑修改
        return target.isAutoComplete || false;
    }

    RefreshSource(cbx: any, items: any[]) {
        // 模拟实现，实际使用时需根据业务逻辑修改
        cbx.itemsSource = items;
    }

    RegisteAutoComplete(cbx: any, items: any[]) {
        // 模拟实现，实际使用时需根据业务逻辑修改
        cbx.itemsSource = items;
    }
}

// 模拟 ItemsControl 类hulei -/ 模拟类型
// class ItemsControl {
//     items: any[] = [];
//     itemsSource: any[] | null = null;
//     isLoaded: boolean = false;
//     isAutoComplete: boolean = false;

//     constructor() {
//         this.items = [];
//     }

//     addEventListener(event: string, callback: (event: any) => void) {
//         // 模拟实现，实际使用时需根据业务逻辑修改
//     }
// }

// 模拟 Selector 类 hulei-s 模拟加载事件 需要重构
// class Selector extends ItemsControl {
//     selectedIndex: number = -1;
//     selectedItem: any = null;
// }

// ItemsControlHelper 类
class ItemsControlHelper {
    private static ComboBoxHelperPropertyKey = Symbol('ComboBoxHelper');

    static GetComboBoxHelper(obj: any): ComboBoxHelper | null {
        return obj[this.ComboBoxHelperPropertyKey] as ComboBoxHelper;
    }

    static SetComboBoxHelper(obj: any, value: ComboBoxHelper) {
        obj[this.ComboBoxHelperPropertyKey] = value;
    }

    static AddItems(items: any[]) {//target: ItemsControl,hulei-s windows自带框架
        if (!items) return;

        for (const item of items) {
            if (this.isKeyValuePair(item)) {
                //target.items.push(item);
            }
        }
    }

    static SetItems(items: any[]) {//target: ItemsControl,hulei-s windows自带框架
        // if (!items) return;

        // if (ComboBoxHelper.GetIsAutoComplete(target)) {
        //     const cbx = target as Selector;
        //     if (!cbx) return;

        //     if (cbx.itemsSource) {
        //         const helper = this.GetComboBoxHelper(cbx);
        //         if (helper) {
        //             helper.RefreshSource(cbx, items);
        //         }
        //     } else {
        //         const helper = new ComboBoxHelper();
        //         this.SetComboBoxHelper(cbx, helper);
        //         if (cbx.isLoaded) {
        //             helper.RegisteAutoComplete(cbx, items);
        //         } else {
        //             cbx.addEventListener('loaded', () => {
        //                 helper.RegisteAutoComplete(cbx, items);
        //             });
        //         }
        //     }
        // } else {
        //     target.items = [];
        //     this.AddItems(target, items);
        //     const selector = target as Selector;
        //     if (selector) {
        //         selector.selectedIndex = 0;
        //     }
        //     // 模拟刷新操作
        //     target.itemsSource = [...target.items];
        // }
    }

    static GetSelectedKey(): string {//hulei-s 系统自带target: Selector
        let result = '';
        // if (target.selectedItem) {
        //     if (this.isKeyValuePair(target.selectedItem)) {
        //         result = target.selectedItem.key;
        //     }
        // }
        return result;
    }

    private static isKeyValuePair(obj: any): obj is { key: string; value: string } {
        return obj && typeof obj.key === 'string' && typeof obj.value === 'string';
    }
}

export { ItemsControlHelper, ComboBoxHelper }; //hulei-s  ItemsControl, Selector,
